



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android实现XML解析技术</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android实现XML解析技术</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 12:24:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>转载：<a href="http://www.cnblogs.com/hanyonglu/archive/2012/02/28/2370675.html" rel="external nofollow noreferrer">Android实现XML解析技术</a></h2>
<p><strong>本文介绍在Android平台中实现对XML的三种解析方式。</strong></p>
<p>XML在各种开发中都广泛应用，Android也不例外。作为承载数据的一个重要角色，如何读写XML成为Android开发中一项重要的技能。</p>
<p>在Android中，常见的XML解析器分别为DOM解析器、SAX解析器和PULL解析器，下面，我将一一向大家详细介绍。</p>
<p><strong>第一种方式：DOM解析器：</strong></p>
<p>DOM是基于树形结构的的节点或信息片段的集合，允许开发人员使用DOM API遍历XML树、检索所需数据。分析该结构通常需要加载整个文档和构造树形结构，然后才可以检索和更新节点信息。Android完全支持DOM 解析。利用DOM中的对象，可以对XML文档进行读取、搜索、修改、添加和删除等操作。</p>
<p>DOM的工作原理：使用DOM对XML文件进行操作时，首先要解析文件，将文件分为独立的元素、属性和注释等，然后以节点树的形式在内存中对XML文件进行表示，就可以通过节点树访问文档的内容，并根据需要修改文档&mdash;&mdash;这就是DOM的工作原理。</p>
<p>DOM实现时首先为XML文档的解析定义一组接口，解析器读入整个文档，然后构造一个驻留内存的树结构，这样代码就可以使用DOM接口来操作整个树结构。</p>
<p>由于DOM在内存中以树形结构存放，因此检索和更新效率会更高。但是对于特别大的文档，解析和加载整个文档将会很耗资源。&nbsp;当然，如果XML文件的内容比较小，采用DOM是可行的。</p>
<p>常用的DoM接口和类：</p>
<p>Document：该接口定义分析并创建DOM文档的一系列方法，它是文档树的根，是操作DOM的基础。</p>
<p>Element：该接口继承Node接口，提供了获取、修改XML元素名字和属性的方法。</p>
<div>
<p>Node：该接口提供处理并获取节点和子节点值的方法。</p>
<p>NodeList：提供获得节点个数和当前节点的方法。这样就可以迭代地访问各个节点。</p>
<p>DOMParser：该类是Apache的Xerces中的DOM解析器类，可直接解析XML文件。</p>
<p>下面是DOM的解析流程：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/689103/201506/191057301077055.jpg" /></p>
</div>
<p><strong> 第二种方式：SAX解析器：</strong></p>
<p>SAX(Simple API for XML)解析器是一种基于事件的解析器，事件驱动的流式解析方式是，从文件的开始顺序解析到文档的结束，不可暂停或倒退。它的核心是事件处理模式，主要是围绕着事件源以及事件处理器来工作的。当事件源产生事件后，调用事件处理器相应的处理方法，一个事件就可以得到处理。在事件源调用事件处理器中特定方法的时候，还要传递给事件处理器相应事件的状态信息，这样事件处理器才能够根据提供的事件信息来决定自己的行为。</p>
<p>SAX解析器的优点是解析速度快，占用内存少。非常适合在Android移动设备中使用。</p>
<p>SAX的工作原理：SAX的工作原理简单地说就是对文档进行顺序扫描，当扫描到文档(document)开始与结束、元素(element)开始与结束、文档(document)结束等地方时通知事件处理函数，由事件处理函数做相应动作，然后继续同样的扫描，直至文档结束。</p>
<p>在SAX接口中，事件源是org.xml.sax包中的XMLReader，它通过parser()方法来解析XML文档，并产生事件。事件处理器是org.xml.sax包中ContentHander、DTDHander、ErrorHandler，以及EntityResolver这4个接口。XMLReader通过相应事件处理器注册方法setXXXX()来完成的与ContentHander、DTDHander、ErrorHandler，以及EntityResolver这4个接口的连接。</p>
<div>常用的SAX接口和类：</div>
<p>Attrbutes：用于得到属性的个数、名字和值。</p>
<p>ContentHandler：定义与文档本身关联的事件(例如，开始和结束标记)。大多数应用程序都注册这些事件。</p>
<p>DTDHandler：定义与DTD关联的事件。它没有定义足够的事件来完整地报告DTD。如果需要对DTD进行语法分析，请使用可选的DeclHandler。</p>
<p>DeclHandler是SAX的扩展。不是所有的语法分析器都支持它。</p>
<p>EntityResolver：定义与装入实体关联的事件。只有少数几个应用程序注册这些事件。</p>
<p>ErrorHandler：定义错误事件。许多应用程序注册这些事件以便用它们自己的方式报错。</p>
<p>DefaultHandler：它提供了这些接LI的缺省实现。在大多数情况下，为应用程序扩展DefaultHandler并覆盖相关的方法要比直接实现一个接口更容易。</p>
<p>详见下表：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/689103/201506/191058537488636.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/689103/201506/191059061238755.jpg" /></p>
<p>可知，我们需要XmlReader 以及DefaultHandler来配合解析xml。</p>
<p>下面是SAX的解析流程：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/689103/201506/191059290459053.jpg" /></p>
<p><strong> 第三种方式：PULL解析器：</strong></p>
<p>Android并未提供对Java StAX API的支持。但是，Android附带了一个pull解析器，其工作方式类似于StAX。它允许用户的应用程序代码从解析器中获取事件，这与SAX解析器自动将事件推入处理程序相反。</p>
<p>PULL解析器的运行方式和SAX类似，都是基于事件的模式。不同的是，在PULL解析过程中返回的是数字，且我们需要自己获取产生的事件然后做相应的操作，而不像SAX那样由处理器触发一种事件的方法，执行我们的代码。</p>
<p>下面是PULL解析XML的过程：</p>
<p>读取到xml的声明返回 START_DOCUMENT;</p>
<blockquote><div>
<p>读取到xml的结束返回 END_DOCUMENT ;</p>
</div>
<div>
<p>读取到xml的开始标签返回 START_TAG</p>
</div>
<div>
<p>读取到xml的结束标签返回 END_TAG</p>
</div>
<div>
<p>读取到xml的文本返回 TEXT</p>
</div></blockquote>
<div>
<p>PULL解析器小巧轻便，解析速度快，简单易用，非常适合在Android移动设备中使用，Android系统内部在解析各种XML时也是用PULL解析器，Android官方推荐开发者们使用Pull解析技术。Pull解析技术是第三方开发的开源技术，它同样可以应用于JavaSE开发。</p>
<p>PULL&nbsp;的工作原理：XML pull提供了开始元素和结束元素。当某个元素开始时，我们可以调用parser．nextText从XML文档中提取所有字符数据。当解释到一个文档结束时，自动生成EndDocument事件。</p>
<p>常用的XML pull的接口和类：</p>
<p>XmlPullParser：XML pull解析器是一个在XMLPULL VlAP1中提供了定义解析功能的接口。</p>
<p>XmlSerializer：它是一个接口，定义了XML信息集的序列。</p>
<p>XmlPullParserFactory：这个类用于在XMPULL V1 API中创建XML Pull解析器。</p>
<p>XmlPullParserException：抛出单一的XML pull解析器相关的错误。</p>
<p>PULL的解析流程如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/689103/201506/191100186385801.jpg" /></p>
<p><strong>&nbsp; &nbsp; &nbsp; [附加]第四种方式：&nbsp;Android.util.Xml类</strong></p>
<div>
<div>在Android API中，另外提供了Android．util．Xml类，同样可以解析XML文件，使用方法类似SAX，也都需编写Handler来处理XML的解析，但是在使用上却比SAX来得简单 ，如下所示：</div>
<div>以android．util．XML实现XML解析 ，</div>
<div>MyHandler myHandler=new MyHandler0；</div>
<div>android．util．Xm1．parse(ur1．openC0nnection()．getlnputStream0，Xm1．Encoding．UTF-8，myHandler)；</div>
</div>
<p><strong>下面是一个参考文档</strong>river.xml，放在assets目录.如下：</p>
<pre class="prettyprint linenums">
&nbsp;<br />
&lt;?xml&nbsp;version="1.0"&nbsp;encoding="utf-8"?&gt;&nbsp;<br />
&lt;rivers&gt;<br />
&nbsp;&lt;river&nbsp;name="灵渠"&nbsp;length="605"&gt;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;introduction&gt;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;灵渠在广西壮族自治区兴安县境内，是世界上最古老的运河之一，有着&ldquo;世界古代水利建筑明珠&rdquo;的美誉。灵渠古称秦凿渠、零渠、陡河、兴安运河，于公元前214年凿成通航，距今已2217年，仍然发挥着功用。<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/introduction&gt;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;imageurl&gt;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;http://imgsrc.baidu.com/baike/pic/item/389aa8fdb7b8322e08244d3c.jpg<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/imageurl&gt;<br />
&nbsp;&nbsp;&nbsp;&lt;/river&gt;&nbsp;<br />
&nbsp;&nbsp;&nbsp;<br />
&nbsp;&nbsp;&nbsp;&lt;river&nbsp;name="胶莱运河"&nbsp;length="200"&gt;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;introduction&gt;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;胶莱运河南起黄海灵山海口，北抵渤海三山岛，流经现胶南、胶州、平度、高密、昌邑和莱州等，全长200公里，流域面积达5400平方公里，南北贯穿山东半岛，沟通黄渤两海。胶莱运河自平度姚家村东的分水岭南北分流。南流由麻湾口入胶州湾，为南胶莱河，长30公里。北流由海仓口入莱州湾,为北胶莱河,长100余公里。<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/introduction&gt;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;imageurl&gt;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;http://imgsrc.baidu.com/baike/pic/item/389aa8fdb7b8322e08244d3c.jpg<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/imageurl&gt;<br />
&nbsp;&nbsp;&nbsp;&lt;/river&gt;<br />
&nbsp;&nbsp;&nbsp;<br />
&nbsp;&nbsp;&nbsp;&lt;river&nbsp;name="苏北灌溉总渠"&nbsp;length="168"&gt;&nbsp;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;introduction&gt;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;位于淮河下游江苏省北部，西起洪泽湖边的高良涧，流经洪泽，青浦、淮安，阜宁、射阳，滨海等六县(区)，东至扁担港口入海的大型人工河道。全长168km。<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/introduction&gt;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;imageurl&gt;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;http://imgsrc.baidu.com/baike/pic/item/389aa8fdb7b8322e08244d3c.jpg<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/imageurl&gt;<br />
&nbsp;&nbsp;&nbsp;&lt;/river&gt;<br />
&nbsp;&lt;/rivers&gt;<br />
&nbsp;
</pre>

<div>
<p><strong>采用DOM解析时具体处理步骤是：</strong></p>
<p>1&nbsp;首先利用DocumentBuilderFactory创建一个DocumentBuilderFactory实例<br />	2&nbsp;然后利用DocumentBuilderFactory创建DocumentBuilder</p>
<p>3&nbsp;然后加载XML文档（Document）,<br />	4&nbsp;然后获取文档的根结点(Element)，<br />	5&nbsp;然后获取根结点中所有子节点的列表（NodeList），<br />	6&nbsp;然后使用再获取子节点列表中的需要读取的结点。</p>
</div>
<p>当然我们观察节点，我需要用一个River对象来保存数据，抽象出River类</p></div>
<pre class="prettyprint linenums">
&nbsp;<br />
public&nbsp;class&nbsp;River&nbsp;implements&nbsp;Serializable&nbsp;{&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />
&nbsp;&nbsp;&nbsp;privatestaticfinallong&nbsp;serialVersionUID&nbsp;=&nbsp;1L;&nbsp;<br />
&nbsp;&nbsp;&nbsp;&nbsp;private&nbsp;String&nbsp;name;<br />
&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;String&nbsp;getName()&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;name;<br />
&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;void&nbsp;setName(String&nbsp;name)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.name&nbsp;=&nbsp;name;<br />
&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;int&nbsp;getLength()&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;length;<br />
&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;void&nbsp;setLength(int&nbsp;length)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.length&nbsp;=&nbsp;length;<br />
&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;String&nbsp;getIntroduction()&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;introduction;<br />
&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;void&nbsp;setIntroduction(String&nbsp;introduction)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.introduction&nbsp;=&nbsp;introduction;<br />
&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;String&nbsp;getImageurl()&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;imageurl;<br />
&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;void&nbsp;setImageurl(String&nbsp;imageurl)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.imageurl&nbsp;=&nbsp;imageurl;<br />
&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;private&nbsp;int&nbsp;length;<br />
&nbsp;&nbsp;&nbsp;&nbsp;private&nbsp;String&nbsp;introduction;<br />
&nbsp;&nbsp;&nbsp;&nbsp;private&nbsp;String&nbsp;imageurl;&nbsp;<br />
}<br />
&nbsp;
</pre>
<p>下面我们就开始读取xml文档对象，并添加进List中：</p>
<p>代码如下： 我们这里是使用assets中的river.xml文件，那么就需要读取这个xml文件，返回输入流。 读取方法为：inputStream=this.context.getResources().getAssets().open(fileName); 参数是xml文件路径，当然默认的是assets目录为根目录。</p>
<p>然后可以用DocumentBuilder对象的parse方法解析输入流，并返回document对象，然后再遍历doument对象的节点属性。</p>
<pre class="prettyprint linenums">
&nbsp;<br />
&nbsp;&nbsp; //获取全部河流数据&nbsp;<br />
&nbsp;&nbsp;&nbsp;/**&nbsp;&nbsp;&nbsp;<br />
&nbsp;&nbsp; &nbsp; *&nbsp;参数fileName：为xml文档路径<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;*/<br />
&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;List&lt;River&gt;&nbsp;getRiversFromXml(String&nbsp;fileName){<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;List&lt;River&gt;&nbsp;rivers=new&nbsp;ArrayList&lt;River&gt;();<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;DocumentBuilderFactory&nbsp;factory=null;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;DocumentBuilder&nbsp;builder=null;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Document&nbsp;document=null;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;InputStream&nbsp;inputStream=null;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//首先找到xml文件<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;factory=DocumentBuilderFactory.newInstance();<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;try&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//找到xml，并加载文档<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;builder=factory.newDocumentBuilder();<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;inputStream=this.context.getResources().getAssets().open(fileName);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;document=builder.parse(inputStream);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//找到根Element<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Element&nbsp;root=document.getDocumentElement();<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;NodeList&nbsp;nodes=root.getElementsByTagName(RIVER);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//遍历根节点所有子节点,rivers&nbsp;下所有river<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;River&nbsp;river=null;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;for(int&nbsp;i=0;i&lt;nodes.getLength();i++){<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river=new&nbsp;River();&nbsp;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//获取river元素节点<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Element&nbsp;riverElement=(Element)(nodes.item(i));<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//获取river中name属性值<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river.setName(riverElement.getAttribute(NAME));<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river.setLength(Integer.parseInt(riverElement.getAttribute(LENGTH)));<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//获取river下introduction标签<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Element&nbsp;introduction=(Element)riverElement.getElementsByTagName(INTRODUCTION).item(0);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river.setIntroduction(introduction.getFirstChild().getNodeValue());<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Element&nbsp;imageUrl=(Element)riverElement.getElementsByTagName(IMAGEURL).item(0);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river.setImageurl(imageUrl.getFirstChild().getNodeValue());&nbsp;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rivers.add(river);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}catch&nbsp;(IOException&nbsp;e){<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;e.printStackTrace();<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;catch&nbsp;(SAXException&nbsp;e)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;e.printStackTrace();<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;catch&nbsp;(ParserConfigurationException&nbsp;e)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;e.printStackTrace();<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}finally{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;try&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;inputStream.close();<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;catch&nbsp;(IOException&nbsp;e)&nbsp;{&nbsp;&nbsp;&nbsp;&nbsp;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;e.printStackTrace();<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;rivers;<br />
&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;
</pre>
<p>在这里添加到List中， 然后我们使用ListView将他们显示出来。如图所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/689103/201506/191101376545428.jpg" /></p>
<h2>由于在Android4.0以后不能将数据写入外置SD卡中，所以我们将数据写入到内置SD卡中，下面是一个完整的例子：</h2>
<p>activity_my_domdemo.xml</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8"?&gt;<br />
&lt;TableLayout xmlns:android="http://schemas.android.com/apk/res/android"<br />
    xmlns:tools="http://schemas.android.com/tools"<br />
    android:layout_width="fill_parent"<br />
    android:layout_height="fill_parent"<br />
    android:paddingBottom="@dimen/activity_vertical_margin"<br />
    android:paddingLeft="@dimen/activity_horizontal_margin"<br />
    android:paddingRight="@dimen/activity_horizontal_margin"<br />
    android:paddingTop="@dimen/activity_vertical_margin"<br />
    tools:context="com.example.myfirst.MyDOMDemo" &gt;

    &lt;TableRow&gt;<br />
        &lt;TextView<br />
            android:layout_width="fill_parent"<br />
            android:layout_height="wrap_content"<br />
            android:textSize="22px"<br />
            android:text="姓名：" /&gt;<br />
        &lt;EditText<br />
            android:id="@+id/name"<br />
            android:layout_width="fill_parent"<br />
            android:layout_height="wrap_content"/&gt;<br />
    &lt;/TableRow&gt;<br />
    &lt;TableRow&gt;<br />
        &lt;TextView<br />
            android:layout_width="fill_parent"<br />
            android:layout_height="wrap_content"<br />
            android:textSize="22px"<br />
            android:text="邮箱：" /&gt;<br />
        &lt;EditText<br />
            android:id="@+id/email"<br />
            android:layout_width="fill_parent"<br />
            android:layout_height="wrap_content"/&gt;<br />
    &lt;/TableRow&gt;<br />
    &lt;TableRow&gt;<br />
        &lt;Button<br />
            android:id="@+id/but"<br />
            android:layout_width="fill_parent"<br />
            android:layout_height="wrap_content"<br />
            android:text="保存"/&gt;"<br />
    &lt;/TableRow&gt;

    &lt;TableRow&gt;<br />
        &lt;TextView<br />
            android:layout_width="fill_parent"<br />
            android:layout_height="wrap_content"<br />
            android:textSize="22px"<br />
            android:text="姓名：" /&gt;<br />
        &lt;TextView<br />
            android:id="@+id/name1"<br />
            android:layout_width="fill_parent"<br />
            android:layout_height="wrap_content"/&gt;<br />
    &lt;/TableRow&gt;<br />
    &lt;TableRow&gt;<br />
        &lt;TextView<br />
            android:layout_width="fill_parent"<br />
            android:layout_height="wrap_content"<br />
            android:textSize="22px"<br />
            android:text="邮箱：" /&gt;<br />
        &lt;TextView<br />
            android:id="@+id/email1"<br />
            android:layout_width="fill_parent"<br />
            android:layout_height="wrap_content"/&gt;<br />
    &lt;/TableRow&gt;<br />
    &lt;TableRow&gt;<br />
        &lt;Button<br />
            android:id="@+id/but1"<br />
            android:layout_width="fill_parent"<br />
            android:layout_height="wrap_content"<br />
            android:text="读取"/&gt;"<br />
    &lt;/TableRow&gt;<br />
&lt;/TableLayout&gt;</pre>
</div>
<p>MyDOMDemo.java</p>
<div>
<pre class="prettyprint linenums">package com.example.myfirst;

import java.io.File;<br />
import java.io.FileNotFoundException;<br />
import java.io.FileOutputStream;<br />
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;<br />
import javax.xml.parsers.DocumentBuilderFactory;<br />
import javax.xml.parsers.ParserConfigurationException;<br />
import javax.xml.transform.OutputKeys;<br />
import javax.xml.transform.Transformer;<br />
import javax.xml.transform.TransformerConfigurationException;<br />
import javax.xml.transform.TransformerException;<br />
import javax.xml.transform.TransformerFactory;<br />
import javax.xml.transform.dom.DOMSource;<br />
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;<br />
import org.w3c.dom.Element;<br />
import org.w3c.dom.NodeList;<br />
import org.xml.sax.SAXException;

import android.support.v7.app.ActionBarActivity;<br />
import android.app.Activity;<br />
import android.os.Bundle;<br />
import android.os.Environment;<br />
import android.view.Menu;<br />
import android.view.MenuItem;<br />
import android.view.View;<br />
import android.view.View.OnClickListener;<br />
import android.widget.Button;<br />
import android.widget.TextView;

public class MyDOMDemo extends ActionBarActivity {<br />
    private TextView name = null;<br />
    private TextView email = null;<br />
    private Button but = null;  //保存按钮<br />
    private TextView name1 = null;<br />
    private TextView email1 = null;<br />
    private Button but1 = null;    //读取按钮<br />
//    private FileOutputStream output = null;<br />
    @Override<br />
    protected void onCreate(Bundle savedInstanceState) {<br />
        super.onCreate(savedInstanceState);<br />
        setContentView(R.layout.activity_my_domdemo);<br />
        this.name = (TextView) super.findViewById(R.id.name);<br />
        this.email = (TextView) super.findViewById(R.id.email);<br />
        this.but = (Button) super.findViewById(R.id.but);<br />
//        try {<br />
//            this.output = super.openFileOutput("member.xml", Activity.MODE_PRIVATE);<br />
//        } catch (FileNotFoundException e) {<br />
//            // TODO Auto-generated catch block<br />
//            e.printStackTrace();<br />
//        }<br />
        this.but.setOnClickListener(new OnClickListenerImpl());<br />
        this.name1 = (TextView) super.findViewById(R.id.name1);<br />
        this.email1 = (TextView) super.findViewById(R.id.email1);<br />
        this.but1 = (Button) super.findViewById(R.id.but1);<br />
        but1.setOnClickListener(new OnClickListenerImpl1());<br />
    }<br />
    private class OnClickListenerImpl implements OnClickListener{

        @Override<br />
        public void onClick(View arg0) {<br />
//            //如果sdcard不存在<br />
//            if(!Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)){<br />
//                return; //返回调用处<br />
//            }<br />
//            File file = new File(Environment.getExternalStorageDirectory().toString()+<br />
//                    File.separator+"mldndata"+File.separator+"member.xml"); //定义File类对象<br />
//            if(!file.getParentFile().exists()){<br />
//                file.getParentFile().mkdirs();      //如果父文件夹不存在，创建文件夹<br />
//            }<br />
            File file = new File("/data/data/com.example.myfirst/files/member.xml");<br />
            if(!file.getParentFile().exists()){<br />
                file.getParentFile().mkdirs();      //如果父文件夹不存在，创建文件夹<br />
            }<br />
            //1.建立DocumentBuilderFactory，用以取得DocumentBuilder<br />
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();<br />
            //2.通过DocumentBuilderFactory取得DocumentBuilder<br />
            DocumentBuilder builder = null;<br />
            try {<br />
                builder = factory.newDocumentBuilder();<br />
            } catch (ParserConfigurationException e) {<br />
                // TODO Auto-generated catch block<br />
                e.printStackTrace();<br />
            }<br />
            //3.定义Document接口对象，通过DocumentBuilder类进行DOM树的转换操作<br />
            Document doc = null;<br />
            doc = builder.newDocument();  //创建一个新的文档<br />
            //4.建立各个操作节点<br />
            Element addresslist = doc.createElement("addresslist");<br />
            Element linkman = doc.createElement("linkman");<br />
            Element name = doc.createElement("name");<br />
            Element email = doc.createElement("email");  //建立节点<br />
            //5.设置节点的文本内容，即为每一个节点添加文本节点<br />
            name.appendChild(doc.createTextNode(MyDOMDemo.this.name.getText().toString()));<br />
            email.appendChild(doc.createTextNode(MyDOMDemo.this.email.getText().toString()));<br />
            //6.设置节点关系<br />
            linkman.appendChild(name);<br />
            linkman.appendChild(email);<br />
            addresslist.appendChild(linkman);<br />
            doc.appendChild(addresslist);<br />
            //7.输出文档到文件中<br />
            TransformerFactory tf = TransformerFactory.newInstance();<br />
            Transformer t = null;<br />
            try {<br />
                t = tf.newTransformer();<br />
            } catch (TransformerConfigurationException e) {<br />
                // TODO Auto-generated catch block<br />
                e.printStackTrace();<br />
            }<br />
            t.setOutputProperty(OutputKeys.ENCODING, "GBK"); //设置编码<br />
            DOMSource source = new DOMSource(doc);    //输出文档<br />
            StreamResult result = new StreamResult(file);  //指定输出位置<br />
//            StreamResult result = new StreamResult(output);<br />
            try {<br />
                t.transform(source, result);<br />
            } catch (TransformerException e) {<br />
                // TODO Auto-generated catch block<br />
                e.printStackTrace();<br />
            }<br />
        }

    }

    private class OnClickListenerImpl1 implements OnClickListener{

        @Override<br />
        public void onClick(View arg0) {<br />
            File file = new File("/data/data/com.example.myfirst/files/member.xml");<br />
            if(!file.getParentFile().exists()){<br />
                file.getParentFile().mkdirs();      //如果父文件夹不存在，创建文件夹<br />
            }<br />
            //1.建立DocumentBuilderFactory，用以取得DocumentBuilder<br />
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();<br />
            //2.通过DocumentBuilderFactory取得DocumentBuilder<br />
            DocumentBuilder builder = null;<br />
            try {<br />
                builder = factory.newDocumentBuilder();<br />
            } catch (ParserConfigurationException e) {<br />
                // TODO Auto-generated catch block<br />
                e.printStackTrace();<br />
            }<br />
            //3.定义Document接口对象，通过DocumentBuilder类进行DOM树的转换操作<br />
            Document doc = null;<br />
            try {<br />
                doc = builder.parse(file);  //读取指定路径的XML文件<br />
            } catch (SAXException e) {<br />
                // TODO Auto-generated catch block<br />
                e.printStackTrace();<br />
            } catch (IOException e) {<br />
                // TODO Auto-generated catch block<br />
                e.printStackTrace();<br />
            }<br />
            //4.查找linkman的节点<br />
            NodeList nl = doc.getElementsByTagName("linkman");<br />
            //5.输出NodeList中第一个子节点中文本节点的内容<br />
            for(int x=0;x&lt;nl.getLength();x++){<br />
                Element e = (Element) nl.item(x);<br />
                MyDOMDemo.this.name1.setText(e.getElementsByTagName("name")<br />
                        .item(0).getFirstChild().getNodeValue());  //设置文本<br />
                MyDOMDemo.this.email1.setText(e.getElementsByTagName("email")<br />
                        .item(0).getFirstChild().getNodeValue());<br />
            }

        }

    }<br />
    @Override<br />
    public boolean onCreateOptionsMenu(Menu menu) {<br />
        // Inflate the menu; this adds items to the action bar if it is present.<br />
        getMenuInflater().inflate(R.menu.my_domdemo, menu);<br />
        return true;<br />
    }

    @Override<br />
    public boolean onOptionsItemSelected(MenuItem item) {<br />
        // Handle action bar item clicks here. The action bar will<br />
        // automatically handle clicks on the Home/Up button, so long<br />
        // as you specify a parent activity in AndroidManifest.xml.<br />
        int id = item.getItemId();<br />
        if (id == R.id.action_settings) {<br />
            return true;<br />
        }<br />
        return super.onOptionsItemSelected(item);<br />
    }<br />
}</pre>
</div>
<p>数据存放位置在虚拟机中可以通过DDMS中的File Explorer查看</p>
<p>存放位置为：File Explorer\data\data\&lt;package name&gt;\files中</p>
<p>程序运行结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/689103/201506/191107521859706.png" /></p>
<p><strong>采用SAX解析时具体处理步骤是：</strong></p>
<p>1 创建SAXParserFactory对象</p>
<p>2 根据SAXParserFactory.newSAXParser()方法返回一个SAXParser解析器</p>
<p>3&nbsp;根据SAXParser解析器获取事件源对象XMLReader</p>
<p>4 实例化一个DefaultHandler对象</p>
<p>5 连接事件源对象XMLReader到事件处理类DefaultHandler中</p>
<p>6 调用XMLReader的parse方法从输入源中获取到的xml数据</p>
<p>7 通过DefaultHandler返回我们需要的数据集合。</p>
<p>代码如下：</p>
<div>
<div>&nbsp;</div>
<div>&nbsp;&nbsp;public&nbsp;List&lt;River&gt;&nbsp;parse(String&nbsp;xmlPath){</div>
<p>List&lt;River&gt;&nbsp;rivers=null;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;SAXParserFactory&nbsp;factory=SAXParserFactory.newInstance();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;try&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;SAXParser&nbsp;parser=factory.newSAXParser();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//获取事件源<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;XMLReader&nbsp;xmlReader=parser.getXMLReader();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//设置处理器<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;RiverHandler&nbsp;handler=new&nbsp;RiverHandler();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;xmlReader.setContentHandler(handler);<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//解析xml文档<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//xmlReader.parse(new&nbsp;InputSource(new&nbsp;URL(xmlPath).openStream()));<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;xmlReader.parse(new&nbsp;InputSource(this.context.getAssets().open(xmlPath)));<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rivers=handler.getRivers();&nbsp;&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;catch&nbsp;(ParserConfigurationException&nbsp;e)&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;TODO&nbsp;Auto-generated&nbsp;catch&nbsp;block<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;e.printStackTrace();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;catch&nbsp;(SAXException&nbsp;e)&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;TODO&nbsp;Auto-generated&nbsp;catch&nbsp;block<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;e.printStackTrace();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;catch&nbsp;(IOException&nbsp;e)&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;e.printStackTrace();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;rivers;<br />&nbsp;&nbsp;&nbsp;&nbsp;}</p>
<div>&nbsp;</div>
</div>
<p>重点在于DefaultHandler对象中对每一个元素节点，属性，文本内容，文档内容进行处理。</p>
<p>前面说过DefaultHandler是基于事件处理模型的，基本处理方式是：当SAX解析器导航到文档开始标签时回调startDocument方法，导航到文档结束标签时回调endDocument方法。当SAX解析器导航到元素开始标签时回调startElement方法，导航到其文本内容时回调characters方法，导航到标签结束时回调endElement方法。</p>
<p>根据以上的解释，我们可以得出以下处理xml文档逻辑：</p>
<p>1：当导航到文档开始标签时，在回调函数startDocument中，可以不做处理，当然你可以验证下UTF-8等等。</p>
<p>2：当导航到rivers开始标签时，在回调方法startElement中可以实例化一个集合用来存贮list，不过我们这里不用，因为在构造函数中已经实例化了。</p>
<p>3：导航到river开始标签时，就说明需要实例化River对象了，当然river标签中还有name ,length属性，因此实例化River后还必须取出属性值，attributes.getValue(NAME)，同时赋予river对象中，同时添加为导航到的river标签添加一个boolean为真的标识，用来说明导航到了river元素。</p>
<p>4:当然有river标签内还有子标签（节点），但是SAX解析器是不知道导航到什么标签的，它只懂得开始，结束而已。那么如何让它认得我们的各个标签呢？当然需要判断了，于是可以使用回调方法startElement中的参数String localName，把我们的标签字符串与这个参数比较下，就可以了。我们还必须让SAX知道，现在导航到的是某个标签，因此添加一个true属性让SAX解析器知道。</p>
<p>5：它还会导航到文本内标签，（就是&lt;img&gt;&lt;/img&gt;里面的内容），回调方法characters，我们一般在这个方法中取出就是&lt;img&gt;&lt;/img&gt;里面的内容，并保存。 6：当然它是一定会导航到结束标签&lt;/river&gt; 或者&lt;/rivers&gt;的，如果是&lt;/river&gt;标签，记得把river对象添加进list中。如果是river中的子标签&lt;/introduction&gt;，就把前面设置标记导航到这个标签的boolean标记设置为false. 按照以上实现思路，可以实现如下代码：</p>
<div>
<div>&nbsp;</div>
<div>&nbsp;	/**导航到开始标签触发**/</div>
<p>publicvoid&nbsp;startElement&nbsp;(String&nbsp;uri,&nbsp;String&nbsp;localName,&nbsp;String&nbsp;qName,&nbsp;Attributes&nbsp;attributes){&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;String&nbsp;tagName=localName.length()!=0?localName:qName;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;tagName=tagName.toLowerCase().trim();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//如果读取的是river标签开始，则实例化River<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(tagName.equals(RIVER)){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;isRiver=true;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river=new&nbsp;River();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/**导航到river开始节点后**/<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river.setName(attributes.getValue(NAME));<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river.setLength(Integer.parseInt(attributes.getValue(LENGTH)));<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//然后读取其他节点<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(isRiver){&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(tagName.equals(INTRODUCTION)){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;xintroduction=true;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}else&nbsp;if(tagName.equals(IMAGEURL)){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ximageurl=true;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/**导航到结束标签触发**/<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;void&nbsp;endElement&nbsp;(String&nbsp;uri,&nbsp;String&nbsp;localName,&nbsp;String&nbsp;qName){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;String&nbsp;tagName=localName.length()!=0?localName:qName;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;tagName=tagName.toLowerCase().trim();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//如果读取的是river标签结束，则把River添加进集合中<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(tagName.equals(RIVER)){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;isRiver=true;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rivers.add(river);<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//然后读取其他节点<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(isRiver){&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(tagName.equals(INTRODUCTION)){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;xintroduction=false;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}else&nbsp;if(tagName.equals(IMAGEURL)){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ximageurl=false;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//这里是读取到节点内容时候回调<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;void&nbsp;characters&nbsp;(char[]&nbsp;ch,&nbsp;int&nbsp;start,&nbsp;int&nbsp;length){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//设置属性值<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(xintroduction){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//解决null问题<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river.setIntroduction(river.getIntroduction()==null?"":river.getIntroduction()+new&nbsp;String(ch,start,length));<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}else&nbsp;if(ximageurl){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//解决null问题<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river.setImageurl(river.getImageurl()==null?"":river.getImageurl()+new&nbsp;String(ch,start,length));<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}</p>
<div>&nbsp;</div>
</div>
<p>运行效果跟上例DOM&nbsp;运行效果相同。</p>
<p><strong>采用PULL解析基本处理方式：</strong></p>
<p>当PULL解析器导航到文档开始标签时就开始实例化list集合用来存贮数据对象。导航到元素开始标签时回判断元素标签类型，如果是river标签，则需要实例化River对象了，如果是其他类型，则取得该标签内容并赋予River对象。当然它也会导航到文本标签，不过在这里，我们可以不用。</p>
<p>根据以上的解释，我们可以得出以下处理xml文档逻辑：</p>
<p>1：当导航到XmlPullParser.START_DOCUMENT，可以不做处理，当然你可以实例化集合对象等等。</p>
<p>2：当导航到XmlPullParser.START_TAG，则判断是否是river标签，如果是，则实例化river对象，并调用getAttributeValue方法获取标签中属性值。</p>
<p>3：当导航到其他标签，比如Introduction时候，则判断river对象是否为空，如不为空，则取出Introduction中的内容，nextText方法来获取文本节点内容</p>
<p>4：当然啦，它一定会导航到XmlPullParser.END_TAG的，有开始就要有结束嘛。在这里我们就需要判读是否是river结束标签，如果是，则把river对象存进list集合中了，并设置river对象为null.</p>
<p>由以上的处理逻辑，我们可以得出以下代码：</p>
<div>
<div>&nbsp;</div>
<div>&nbsp; &nbsp;&nbsp;public&nbsp;List&lt;River&gt;&nbsp;parse(String&nbsp;xmlPath){</div>
<p>List&lt;River&gt;&nbsp;rivers=new&nbsp;ArrayList&lt;River&gt;();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;River&nbsp;river=null;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;InputStream&nbsp;inputStream=null;&nbsp;&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//获得XmlPullParser解析器<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;XmlPullParser&nbsp;xmlParser&nbsp;=&nbsp;Xml.newPullParser();&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;try&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//得到文件流，并设置编码方式<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;inputStream=this.context.getResources().getAssets().open(xmlPath);<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;xmlParser.setInput(inputStream,&nbsp;"utf-8");<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//获得解析到的事件类别，这里有开始文档，结束文档，开始标签，结束标签，文本等等事件。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;int&nbsp;evtType=xmlParser.getEventType();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//一直循环，直到文档结束&nbsp;&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;while(evtType!=XmlPullParser.END_DOCUMENT){&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;switch(evtType){&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;case&nbsp;XmlPullParser.START_TAG:<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;String&nbsp;tag&nbsp;=&nbsp;xmlParser.getName();&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//如果是river标签开始，则说明需要实例化对象了<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(tag.equalsIgnoreCase(RIVER))&nbsp;{&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river&nbsp;=&nbsp;new&nbsp;River();&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//取出river标签中的一些属性值<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river.setName(xmlParser.getAttributeValue(null,&nbsp;NAME));<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river.setLength(Integer.parseInt(xmlParser.getAttributeValue(null,&nbsp;LENGTH)));<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}else&nbsp;if(river!=null){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//如果遇到introduction标签，则读取它内容<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(tag.equalsIgnoreCase(INTRODUCTION)){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river.setIntroduction(xmlParser.nextText());<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}else&nbsp;if(tag.equalsIgnoreCase(IMAGEURL)){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river.setImageurl(xmlParser.nextText());<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;break;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;case&nbsp;XmlPullParser.END_TAG:<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//如果遇到river标签结束，则把river对象添加进集合中<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(xmlParser.getName().equalsIgnoreCase(RIVER)&nbsp;&amp;&amp;&nbsp;river&nbsp;!=&nbsp;null)&nbsp;{&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rivers.add(river);&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;river&nbsp;=&nbsp;null;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;break;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;default:break;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//如果xml没有结束，则导航到下一个river节点<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;evtType=xmlParser.next();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;catch&nbsp;(XmlPullParserException&nbsp;e)&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;TODO&nbsp;Auto-generated&nbsp;catch&nbsp;block<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;e.printStackTrace();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}catch&nbsp;(IOException&nbsp;e1)&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;TODO&nbsp;Auto-generated&nbsp;catch&nbsp;block<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;e1.printStackTrace();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;rivers;</p>
<p>}</p>
<div>&nbsp;</div>
</div>
<p>运行效果和上面的一样。</p>
<p><strong>几种解析技术的比较与总结：&nbsp;&nbsp;</strong></p>
<p>对于Android的移动设备而言，因为设备的资源比较宝贵，内存是有限的，所以我们需要选择适合的技术来解析XML，这样有利于提高访问的速度。</p>
<p>1 DOM在处理XML文件时，将XML文件解析成树状结构并放入内存中进行处理。当XML文件较小时，我们可以选DOM，因为它简单、直观。</p>
<p>2 SAX则是以事件作为解析XML文件的模式，它将XML文件转化成一系列的事件，由不同的事件处理器来决定如何处理。XML文件较大时，选择SAX技术是比较合理的。虽然代码量有些大，但是它不需要将所有的XML文件加载到内存中。这样对于有限的Android内存更有效，而且Android提供了一种传统的SAX使用方法以及一个便捷的SAX包装器。 使用Android．util．Xml类，从示例中可以看出，会比使用 SAX来得简单。</p>
<p>3 XML pull解析并未像SAX解析那样监听元素的结束，而是在开始处完成了大部分处理。这有利于提早读取XML文件，可以极大的减少解析时间，这种优化对于连接速度较漫的移动设备而言尤为重要。对于XML文档较大但只需要文档的一部分时，XML Pull解析器则是更为有效的方法。</p>
<p>以上便是在Android平台中对XML进行解析的方法和使用过程。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7oegj8.html">ABP理论学习之OData集成&lpar;新增&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k2j058.html">ssh整合需要那些jar</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq465je8.html">java 22 - 12 多线程之解决线程安全问题的实现方式1</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pedmk8.html">Rest API 开发 学习笔记&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnx2vg9.html">sqoop1&period;99&period;6 update导出语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn11oo38.html">MyEclipse生成WAR包并在Tomcat下部署发布&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd5y4m8.html">Jedis编程设计：连接池</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv0j01q.html">PHP中正则替换函数preg&lowbar;replace用法笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z71m29.html">pydev出现Project interpreter not specified&lpar;eclipse&plus;pydev&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1z4gz9.html">NSLog用法，打印日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdo4pr8.html">poj 2431</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjwvkk8.html">使用Homebrew配置Java开发环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mekgdpq.html">css文本样式及控制文本的大小写</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd1ld49.html">PKCS RSA执行标准</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjm6d39.html">Codeforces Global Round 1 自闭记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj7v7l9.html">Oracle用户密码认证方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jrdw0q.html">intellij idea 搜索功能快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw075y8.html">yum被锁定：Another app is currently holding the yum lock&semi; waiting for it to exit&hellip;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zym7ld9.html">AngularJS 事件广播与接收 &dollar;broadcast&comma;&dollar;emit&comma;&dollar;on 作用域间通信 封装factory服务 发布订阅</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1xl1xq.html">Jquery操作样式</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rdykpe8.html">RHAS Linux下架构Lotus Domino详解（附视频）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wm65oq.html">统一入口的Ajax验证</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxno40d8.html">详解Android定位</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mlw1jq.html">深入学习JavaScript对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd4lkxq.html">Python基础－函数（function）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjk6oz9.html">HDU 5444 Elven Postman （二叉树，暴力搜索）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mlvk1q.html">commondline 之三 执行jar文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okvr2l9.html">hdoj 5326 Work</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmn0019.html">jdbc调用存储过程的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnomjj8.html">How to bind to data when the DataContext is not inherited【项目】</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
